#include <stdexcept>
#include "Vec.h"
#include "grade.h"
#include "median.h"
#include "Student_info.h"

using std::domain_error;


// oblicz ocen kocow studenta na podstawie oceny rdsemestralnej
// i oceny egzaminu kocowego oraz oceny pracy domowych
double grade(double midterm, double final, double homework)
{
	return 0.2 * midterm + 0.4 * final + 0.4 * homework;
}

// oblicz ocen kocow studenta na podstawie oceny rdsemestralnej i oceny egzaminu kocowego
// oraz wektora Vec ocen prac domowych.
// funkcja nie kopiuje argumentu wywoania, poniewa kopiowanie odbywa si w funkcji `median'.
double grade(double midterm, double final, const Vec<double>& hw)
{
	if (hw.size() == 0)
		throw domain_error("student nie odrobi prac domowych");
	return grade(midterm, final, median(hw));
}

double grade(const Student_info& s)
{
	return grade(s.midterm, s.final, s.homework);
}

